local dmg = module.internal("damage")
local ts = module.internal("TS")
local pred = module.internal("pred")
local orb = module.internal("orb")

local spell_parent = module.load("GG-AIO", "spell")
local spell = class(spell_parent)

local common = module.load("GG-AIO","common")

local getTar = ts.get_result
spell.slot = SpellSlot.E
spell.pred = {
    range = 1000,
    radius = 200,
    delay = 0.25
}
spell.target = nil


function spell:__init(menu)
    self:__super(menu)
end
-- add E+R combo logic ?
function spell:makeMenu()
    self.menu:set("texture",player:spellSlot(self.slot).sprite)
    self.menu:header("ecombo","Combo")
    self.menu:boolean("mfuseecombo", "Use E in combo", true)
    self.menu:header("esafetybb","Safety bubble")
    self.menu:boolean("ebbenabled","Enabled", true)
    self.menu:slider("ebbrange","Safety bubble range", 600, 200, 1000, 50)
    self.menu:slider("ebbmana","Min mana", 30, 0, 100, 1)
end

local function normalFilter(res, tar, dist)
    -- returns the best target in range
    if dist > spell.pred.range then
        return false
    end
    res.obj = tar
    return true
end

function spell:updateTarget()
    -- updates self.target with the best target
    local res = getTar(normalFilter, nil, false, true)
    if not res or not res.obj then
        return
    end
    if res.obj:isValidTarget() then 
        self.target = res.obj
    end
end

function spell:combo(obj_table)
    local delay = 0.3
    local count = 0
    local margin = 150
    for hero in objManager.heroes{ team = TEAM_ENEMY, dist = self.pred.range, valid_target = true } do
        count = count+1
    end
    if self.target and self:usable() and count<=2 then
        local future_pos = pred.core.get_pos_after_time(self.target, delay)
        if (self.target:dist() < player.attackRange + player.boundingRadius + margin) and (future_pos:dist(player.pos) > player.attackRange + player.boundingRadius + margin) then
            player:castSpell("pos",self.slot,future_pos)
        end
    end
end

function spell:safetyBubble(obj_table)
    if self.menu.ebbenabled:get() and common:check_mana(self.menu.ebbmana:get()) then
        for _,obj in pairs(obj_table) do
            if obj.isHero and obj:dist()<self.menu.ebbrange:get() and obj.isMelee then
                player:castSpell("pos",self.slot,(obj.pos - player.pos)/2 + player.pos)
            end
        end
    end
end

return spell