local dmg = module.internal("damage")
local ts = module.internal("TS")
local pred = module.internal("pred")
local orb = module.internal("orb")

local spell_parent = module.load("GG-AIO", "spell")
local spell = class(spell_parent)

local common = module.load("GG-AIO","common")

local getTar = ts.get_result
spell.slot = SpellSlot.W
spell.buffname = "missfortunestrutstacks"
spell.dmg_delay = 0.85
spell.last_dmg = 0.5 -- time without damage before w reactivates
spell.last_health_value = player.health
spell.last_health_time = 0
spell.w_clear_range = 1000


function spell:__init(menu)
    self:__super(menu)
end
function spell:makeMenu()
    self.menu:set("texture",player:spellSlot(self.slot).sprite)
    self.menu:header("wcombo","Combo")
    self.menu:boolean("mfusewcombo","Use Q in Combo", true)
    self.menu:header("wharass","Harass")
    self.menu:boolean("mfusewharass", "Use W in Harass", true)
    self.menu:slider("mfwharassmana","Minimum mana percentage needed", 30, 0, 100, 1)
    self.menu:header("wclear","Lane Clear")
    self.menu:boolean("mfusewclear","Use W in lane clear", true)
    self.menu:slider("mfwminminion","Minimum minions to use", 6,0,10,1)
    self.menu:slider("mfwclearmana", "Minimum mana percentage needed", 30, 0, 100, 1)
    self.menu:header("wmisc", "Misc")
    self.menu:boolean("mfwautoboost","Auto ms boost if no damage incoming",true)
    self.menu:slider("mfwboostmana", "Minimum mana percentage needed", 50, 0, 100, 1)

end

function spell:checkHealthDecrease()
    if player.health < self.last_health_value then
        self.last_health_time = game.time
    end
    self.last_health_value = player.health
end

function spell:boost()
    local buff = player:findBuffByName(spell.buffname)
    if self:usable() and not buff and ((game.time - self.last_health_time) > self.last_dmg) and dmg.predict(player,self.dmg_delay)>=player.health and not player:findBuffByName("recall") then
        player:castSpell("self",self.slot)
    end
end

function spell:combo()
    if not self.menu.mfwautoboost:get() then
        self:boost()
    end
    if self:usable() and orb.core.can_spell_after_attack(0.1, true) then
        player:castSpell("self",self.slot)
    end
end

function spell:harass()
    if orb.core.can_spell_after_attack(0.1, true) then
        player:castSpell("self",self.slot)
    end
end

function spell:clear(obj_table)
    local count = 0
    for _,obj in pairs(obj_table) do
        if obj.isMinion and (obj:dist() < self.w_clear_range) then
            count = count + 1
        end 
    end
    if count>=self.menu.mfwminminion:get() then
        player:castSpell("self",self.slot)
    end
end

return spell
