local orb = module.internal("orb")
local pred = module.internal("pred")

local common = module.load("GG-AIO", "common")()

local menu = menu("GG-AIO", "GG MissFortune")
local Q = module.load("GG-AIO", "MissFortune/Q")(menu)
local W = module.load("GG-AIO", "MissFortune/W")(menu)
local E = module.load("GG-AIO", "MissFortune/E")(menu)

local updateobj_range = 2000
local obj_table = {}


local function updateObj()
    local tab1 = {}
    local tab2 = {}
    for hero in objManager.heroes{ team = TEAM_ENEMY, dist = updateobj_range, valid_target = true } do
        table.insert(tab1,hero)
    end
    for minion in objManager.minions{ team = TEAM_ENEMY, dist = updateobj_range, valid_target = true } do
        table.insert(tab2,minion)
    end
    obj_table = common:concatArray(tab1,tab2)
end

local function Combo()
    if Q.menu.mfuseqcombo:get() then
        Q:combo()
    end
    if W.menu.mfusewcombo:get() then
        W:combo()
    end
    if E.menu.mfuseecombo:get() then
        E:combo()
    end
end

local function Mixed()
    if Q.menu.mfuseqharass:get() and common:check_mana(Q.menu.mfqharassmana:get()) then
        Q:harass(obj_table)
    end
    if W.menu.mfusewharass:get() and common:check_mana(W.menu.mfwharassmana:get()) then
        W:harass(obj_table)
    end
end

local function LaneClear()
    if Q.menu.mfuseqclear:get() and common:check_mana(Q.menu.mfqclearmana:get()) then
        Q:clear(obj_table)
    end
    if W.menu.mfusewclear:get() and common:check_mana(W.menu.mfwclearmana:get()) then
        W:clear(obj_table)
    end
end

local function checkMode()
    if orb.core.is_mode_active(OrbwalkingMode.Combo) then
        Combo()
    elseif orb.core.is_mode_active(OrbwalkingMode.Mixed) then
        Mixed()
    elseif orb.core.is_mode_active(OrbwalkingMode.LaneClear) then
        LaneClear()
    end
end

local function updateTarget()
    Q:updateTarget()
    E:updateTarget()
end

local function onTick()
    Q.kalman:UpdateSpeed()
    W:checkHealthDecrease()
    E:safetyBubble(obj_table)
    Q:updateRange()
    if Q.menu.mfuseqharass:get() and Q.menu.mfautoqharass:get() and common:check_mana(Q.menu.mfqharassmana:get()) and not orb.core.is_mode_active(OrbwalkingMode.Combo) then
        Q:bouncehit(obj_table)
    end
    if W.menu.mfwautoboost:get() and common:check_mana(W.menu.mfwboostmana:get()) then
        W:boost()
    end
    checkMode()
end

local function draw()
    Q:draw(obj_table)
end

local function slowTick()
    updateTarget()
    updateObj()
end

cb.add(cb.draw,draw)
cb.add(cb.tick,onTick)
cb.add(cb.slow_tick, slowTick)